# Custom methods for Array and its descendants.
class Array
  # Converts an Array to a Delegation
  def to_del
    Delegation.new(self)
  end

  # Converts an Array to a Representative
  def to_rep
    Representative[to_h]
  end
end

# Custom methods for Hash and its descendants.
class Hash
  # Wraps a Hash in a Delegation
  def to_del
    del = Delegation.new
    del << self
  end

  # Converts a Hash to a Representative
  def to_rep
    Representative[self]
  end
end
